#!/usr/bin/perl -w

if (scalar(@ARGV) != 1) { die "Usage: $0 <filename.raw>\n"; }
open IN, $ARGV[0] or die "Can't open input file: $!\n";
$outfile = $ARGV[0];
$outfile =~ s/\.raw$/\.asm/;
if ($outfile eq $ARGV[0]) { $outfile = $ARGV[0] . ".asm"; }
open OUT, ">$outfile" or die "Can't open output file: $!\n";
$n = 0;
do {
	if (read(IN, $b, 1) != 1) { die "Read error.\n"; }
	$b = unpack('C', $b);
	if ($n % 16 == 0) { print OUT ".db "; }
	printf OUT "\$%02x", $b;
	if (++$n % 16 == 0) { print OUT "\n"; } else { print OUT "," };
} while (!eof(IN));

if ($n % 16 == 0) { print OUT ".db "; }
if ($n % 2 == 0) { print OUT "\$00,"; } # avoid "odd # of bytes" warning
print OUT "\$00\n";



close IN;
close OUT;